scala.collection.immutable

# HashSet

#### class HashSet[A] extends Set[A] with GenericSetTemplate[A, HashSet] with SetLike[A, HashSet[A]] with CustomParallelizable[A, ParHashSet[A]] with Serializable

This class implements immutable sets using a hash trie.

Note: the builder of a hash set returns specialized representations `EmptySet`,`Set1`,..., `Set4` for sets of `size <= 4`.

A

  the type of the elements contained in this hash set.

Annotations
  @SerialVersionUID( uid = 2L )
Source
  HashSet.scala
Version

  2.8

Since

  2.3

Linear Supertypes
Serializable, Serializable, CustomParallelizable[A, ParHashSet[A]], Set[A], Set[A], SetLike[A, HashSet[A]], Subtractable[A, HashSet[A]], GenSet[A], GenericSetTemplate[A, HashSet], GenSetLike[A, HashSet[A]], (A) ⇒ Boolean, Iterable[A], Iterable[A], IterableLike[A, HashSet[A]], Equals, GenIterable[A], GenIterableLike[A, HashSet[A]], Traversable[A], Immutable, Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, HashSet], TraversableLike[A, HashSet[A]], GenTraversableLike[A, HashSet[A]], Parallelizable[A, ParHashSet[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, HashSet[A]], HasNewBuilder[A, HashSet[A]], AnyRef, Any
Known Subclasses
HashSet1, HashTrieSet
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. HashSet
2. Serializable
3. Serializable
4. CustomParallelizable
5. Set
6. Set
7. SetLike
8. Subtractable
9. GenSet
10. GenericSetTemplate
11. GenSetLike
12. Function1
13. Iterable
14. Iterable
15. IterableLike
16. Equals
17. GenIterable
18. GenIterableLike
19. Traversable
20. Immutable
21. Traversable
22. GenTraversable
23. GenericTraversableTemplate
24. TraversableLike
25. GenTraversableLike
26. Parallelizable
27. TraversableOnce
28. GenTraversableOnce
29. FilterMonadic
30. HasNewBuilder
31. AnyRef
32. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new HashSet()

### Type Members

1. #### type Self = HashSet[A]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

2. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def &(that: GenSet[A]): HashSet[A]

   Computes the intersection between this set and another set.

   Computes the intersection between this set and another set.

   Note: Same as `intersect`.

   that

     the set to intersect with.

   returns

     a new set consisting of all elements that are both in this set and in the given set `that`.

   Definition Classes
     GenSetLike

5. #### def &~(that: GenSet[A]): HashSet[A]

   The difference of this set and another set.

   The difference of this set and another set.

   Note: Same as `diff`.

   that

     the set of elements to exclude.

   returns

     a set containing those elements of this set that are not also contained in the given set `that`.

   Definition Classes
     GenSetLike

6. #### def +(elem1: A, elem2: A, elems: A*): HashSet[A]

   Creates a new immutable hash set with additional elements.

   Creates a new immutable hash set with additional elements.

   This method takes two or more elements to be added. Another overloaded variant of this method handles the case where a single element is added.

   elem1

     the first element to add.

   elem2

     the second element to add.

   elems

     the remaining elements to add.

   returns

     a new immutable hash set with the given elements added.

   Definition Classes
     HashSet → SetLike

7. #### def +(e: A): HashSet[A]

   Creates a new set with an additional element, unless the element is already present.

   Creates a new set with an additional element, unless the element is already present.

   returns

     a new set that contains all elements of this set and that also contains `elem`.

   Definition Classes
     HashSet → SetLike → GenSetLike

8. #### def ++(elems: GenTraversableOnce[A]): HashSet[A]

   Creates a new immutable hash set by adding all elements contained in another collection to this immutable hash set.

   Creates a new immutable hash set by adding all elements contained in another collection to this immutable hash set.

   elems

     the collection containing the added elements.

   returns

     a new immutable hash set with the given elements added.

   Definition Classes
     SetLike

9. #### abstract def ++[B](that: GenTraversableOnce[B]): immutable.HashSet[B]

   [use case] Returns a new immutable hash set containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new immutable hash set containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the immutable hash set is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this immutable hash set followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

10. #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[HashSet[A], B, That]): That

    Returns a new immutable hash set containing the elements from the left hand operand followed by the elements from the right hand operand.

    Returns a new immutable hash set containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the immutable hash set is the most specific superclass encompassing the element types of the two operands (see example).

    Example:

            scala> val a = LinkedList(1)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

            scala> val b = LinkedList(2)
            b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

            scala> val c = a ++ b
            c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

            scala> val d = LinkedList('a')
            d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

            scala> val e = c ++ d
            e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    that

      the traversable to append.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` which contains all elements of this immutable hash set followed by all elements of `that`.

    Definition Classes
      TraversableLike → GenTraversableLike

11. #### def ++:[B >: A, That](that: Traversable[B])(implicit bf: CanBuildFrom[HashSet[A], B, That]): That

    As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

    As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

    Example:

            scala> val x = List(1)
            x: List[Int] = List(1)

            scala> val y = LinkedList(2)
            y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

            scala> val z = x ++: y
            z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

    This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

    Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    that

      the traversable to append.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new immutable hash set which contains all elements of this immutable hash set followed by all elements of `that`.

    Definition Classes
      TraversableLike

12. #### abstract def ++:[B](that: TraversableOnce[B]): immutable.HashSet[B]

    [use case] Concatenates this immutable hash set with the elements of a traversable collection.

    [use case]

    Concatenates this immutable hash set with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

    B

      the element type of the returned collection.

    that

      the traversable to append.

    returns

      a new collection of type `That` which contains all elements of this immutable hash set followed by all elements of `that`.

    Definition Classes
      TraversableLike

13. #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[HashSet[A], B, That]): That

    Concatenates this immutable hash set with the elements of a traversable collection.

    Concatenates this immutable hash set with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

    Example:

            scala> val x = List(1)
            x: List[Int] = List(1)

            scala> val y = LinkedList(2)
            y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

            scala> val z = x ++: y
            z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    that

      the traversable to append.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` which contains all elements of this immutable hash set followed by all elements of `that`.

    Definition Classes
      TraversableLike

14. #### def -(e: A): HashSet[A]

    Creates a new set with a given element removed from this set.

    Creates a new set with a given element removed from this set.

    returns

      a new set that contains all elements of this set but that does not contain `elem`.

    Definition Classes
      HashSet → SetLike → Subtractable → GenSetLike

15. #### def -(elem1: A, elem2: A, elems: A*): HashSet[A]

    Creates a new immutable hash set from this immutable hash set with some elements removed.

    Creates a new immutable hash set from this immutable hash set with some elements removed.

    This method takes two or more elements to be removed. Another overloaded variant of this method handles the case where a single element is removed.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      a new immutable hash set that contains all elements of the current immutable hash set except one less occurrence of each of the given elements.

    Definition Classes
      Subtractable

16. #### def --(xs: GenTraversableOnce[A]): HashSet[A]

    Creates a new immutable hash set from this immutable hash set by removing all elements of another collection.

    Creates a new immutable hash set from this immutable hash set by removing all elements of another collection.

    returns

      a new immutable hash set that contains all elements of the current immutable hash set except one less occurrence of each of the elements of `elems`.

    Definition Classes
      Subtractable

17. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this immutable hash set, going left to right.

    Applies a binary operator to a start value and all elements of this immutable hash set, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this immutable hash set, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this immutable hash set.

    Definition Classes
      TraversableOnce → GenTraversableOnce

18. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

19. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this immutable hash set and a start value, going right to left.

    Applies a binary operator to all elements of this immutable hash set and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this immutable hash set, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this immutable hash set.

    Definition Classes
      TraversableOnce → GenTraversableOnce

20. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

21. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

22. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this immutable hash set to a string builder.

    Appends all elements of this immutable hash set to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this immutable hash set without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

23. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this immutable hash set to a string builder using a separator string.

    Appends all elements of this immutable hash set to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this immutable hash set, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

24. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this immutable hash set to a string builder using start, end, and separator strings.

    Appends all elements of this immutable hash set to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this immutable hash set are separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, "LinkedList(", ", ", ")")
             res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

25. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

26. #### def andThen[A](g: (Boolean) ⇒ A): (A) ⇒ A

    Composes two instances of Function1 in a new Function1, with this function applied first.

    Composes two instances of Function1 in a new Function1, with this function applied first.

    A

      the result type of function `g`

    g

      a function R => A

    returns

      a new function `f` such that `f(x) == g(apply(x))`

    Definition Classes
      Function1

27. #### def apply(elem: A): Boolean

    Tests if some element is contained in this set.

    Tests if some element is contained in this set.

    This method is equivalent to `contains`. It allows sets to be interpreted as predicates.

    elem

      the element to test for membership.

    returns

      `true` if `elem` is contained in this set, `false` otherwise.

    Definition Classes
      GenSetLike → Function1

28. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

29. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this immutable hash set should be compared

    returns

      `true`, if this immutable hash set can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

30. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

31. #### abstract def collect[B](pf: PartialFunction[A, B]): immutable.HashSet[B]

    [use case] Builds a new collection by applying a partial function to all elements of this immutable hash set on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this immutable hash set on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the immutable hash set.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

32. #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[HashSet[A], B, That]): That

    Builds a new collection by applying a partial function to all elements of this immutable hash set on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this immutable hash set on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the immutable hash set.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

33. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the immutable hash set for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the immutable hash set for which the given partial function is defined, and applies the partial function to it.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

34. #### def companion: GenericCompanion[HashSet]

    The factory companion object that builds instances of class immutable.

    The factory companion object that builds instances of class immutable.HashSet. (or its `Iterable` superclass where class immutable.HashSet is not a `Seq`.)

    Definition Classes
      HashSet → Set → Set → GenSet → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

35. #### def compose[A](g: (A) ⇒ A): (A) ⇒ Boolean

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1

36. #### def contains(e: A): Boolean

    Tests if some element is contained in this set.

    Tests if some element is contained in this set.

    returns

      `true` if `elem` is contained in this set, `false` otherwise.

    Definition Classes
      HashSet → SetLike → GenSetLike

37. #### abstract def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this immutable hash set to an array.

    [use case]

    Copies elements of this immutable hash set to an array. Fills the given array `xs` with at most `len` elements of this immutable hash set, starting at position `start`. Copying will stop once either the end of the current immutable hash set is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

38. #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this immutable hash set to an array.

    Copies elements of this immutable hash set to an array. Fills the given array `xs` with at most `len` elements of this immutable hash set, starting at position `start`. Copying will stop once either the end of the current immutable hash set is reached, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

39. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this immutable hash set to an array.

    [use case]

    Copies values of this immutable hash set to an array. Fills the given array `xs` with values of this immutable hash set. Copying will stop once either the end of the current immutable hash set is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

40. #### def copyToArray[B >: A](xs: Array[B]): Unit

    Copies values of this immutable hash set to an array.

    Copies values of this immutable hash set to an array. Fills the given array `xs` with values of this immutable hash set. Copying will stop once either the end of the current immutable hash set is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

41. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this immutable hash set to an array.

    [use case]

    Copies values of this immutable hash set to an array. Fills the given array `xs` with values of this immutable hash set, beginning at index `start`. Copying will stop once either the end of the current immutable hash set is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

42. #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

    Copies values of this immutable hash set to an array.

    Copies values of this immutable hash set to an array. Fills the given array `xs` with values of this immutable hash set, beginning at index `start`. Copying will stop once either the end of the current immutable hash set is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

43. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this immutable hash set to a buffer.

    Copies all elements of this immutable hash set to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

44. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the immutable hash set which satisfy a predicate.

    Counts the number of elements in the immutable hash set which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

45. #### def diff(that: GenSet[A]): HashSet[A]

    Computes the difference of this set and another set.

    Computes the difference of this set and another set.

    that

      the set of elements to exclude.

    returns

      a set containing those elements of this set that are not also contained in the given set `that`.

    Definition Classes
      SetLike → GenSetLike

46. #### def drop(n: Int): HashSet[A]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this immutable hash set.

    returns

      a immutable hash set consisting of all elements of this immutable hash set except the first `n` ones, or else the empty immutable hash set, if this immutable hash set has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

47. #### def dropRight(n: Int): HashSet[A]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      The number of elements to take

    returns

      a immutable hash set consisting of all elements of this immutable hash set except the last `n` ones, or else the empty immutable hash set, if this immutable hash set has less than `n` elements.

    Definition Classes
      IterableLike

48. #### def dropWhile(p: (A) ⇒ Boolean): HashSet[A]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this immutable hash set whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

49. #### def elemHashCode(key: A): Int

    Attributes
      protected

50. #### def empty: HashSet[A]

    The empty set of the same type as this set

    The empty set of the same type as this set

    returns

      an empty set of type `This`.

    Definition Classes
      HashSet → SetLike → GenericSetTemplate

51. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

52. #### def equals(that: Any): Boolean

    Compares this set with another object for equality.

    Compares this set with another object for equality.

    Note: This operation contains an unchecked cast: if `that` is a set, it will assume with an unchecked cast that it has the same element type as this set. Any subsequent ClassCastException is treated as a `false` result.

    that

      the other object

    returns

      `true` if `that` is a set which contains the same elements as this set.

    Definition Classes
      GenSetLike → Equals → AnyRef → Any

53. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this immutable hash set.

    Tests whether a predicate holds for some of the elements of this immutable hash set.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this immutable hash set, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

54. #### def filter(p: (A) ⇒ Boolean): HashSet[A]

    Selects all elements of this immutable hash set which satisfy a predicate.

    Selects all elements of this immutable hash set which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new immutable hash set consisting of all elements of this immutable hash set that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

55. #### def filterNot(p: (A) ⇒ Boolean): HashSet[A]

    Selects all elements of this immutable hash set which do not satisfy a predicate.

    Selects all elements of this immutable hash set which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new immutable hash set consisting of all elements of this immutable hash set that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

56. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

57. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the immutable hash set satisfying a predicate, if any.

    Finds the first element of the immutable hash set satisfying a predicate, if any.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the immutable hash set that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

58. #### abstract def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): immutable.HashSet[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable hash set and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable hash set and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this immutable hash set and concatenating the results.

    Definition Classes
      GenTraversableLike

59. #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[HashSet[A], B, That]): That

    Builds a new collection by applying a function to all elements of this immutable hash set and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this immutable hash set and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of immutable hash set. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this immutable hash set and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

60. #### abstract def flatten[B]: immutable.HashSet[B]

    [use case] Converts this immutable hash set of traversable collections into a immutable hash set formed by the elements of these traversable collections.

    [use case]

    Converts this immutable hash set of traversable collections into a immutable hash set formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new immutable hash set resulting from concatenating all element immutable hash sets.

    Definition Classes
      GenericTraversableTemplate

61. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this immutable hash set using the specified associative binary operator.

    Folds the elements of this immutable hash set using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

62. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this immutable hash set, going left to right.

    Applies a binary operator to a start value and all elements of this immutable hash set, going left to right.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this immutable hash set, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this immutable hash set.

    Definition Classes
      TraversableOnce → GenTraversableOnce

63. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this immutable hash set and a start value, going right to left.

    Applies a binary operator to all elements of this immutable hash set and a start value, going right to left.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this immutable hash set, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this immutable hash set.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

64. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this immutable hash set.

    Tests whether a predicate holds for all elements of this immutable hash set.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this immutable hash set, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

65. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this immutable hash set.

    [use case]

    Applies a function `f` to all elements of this immutable hash set.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

66. #### def foreach[U](f: (A) ⇒ U): Unit

    Applies a function `f` to all elements of this immutable hash set.

    Applies a function `f` to all elements of this immutable hash set.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      HashSet → IterableLike → GenericTraversableTemplate → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

67. #### def genericBuilder[B]: Builder[B, HashSet[B]]

    The generic builder that builds instances of immutable.

    The generic builder that builds instances of immutable.HashSet at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

68. #### def get0(key: A, hash: Int, level: Int): Boolean

    Attributes
      protected

69. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

70. #### def groupBy[K](f: (A) ⇒ K): Map[K, HashSet[A]]

    Partitions this immutable hash set into a map of immutable hash sets according to some discriminator function.

    Partitions this immutable hash set into a map of immutable hash sets according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new immutable hash set.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to immutable hash sets such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a immutable hash set of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

71. #### def grouped(size: Int): Iterator[HashSet[A]]

    Partitions elements in fixed size immutable hash sets.

    Partitions elements in fixed size immutable hash sets.

    size

      the number of elements per group

    returns

      An iterator producing immutable hash sets of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

72. #### def hasDefiniteSize: Boolean

    Tests whether this immutable hash set is known to have a finite size.

    Tests whether this immutable hash set is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

73. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      GenSetLike → AnyRef → Any

74. #### def head: A

    Selects the first element of this immutable hash set.

    Selects the first element of this immutable hash set.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this immutable hash set.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the immutable hash set is empty.

75. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this immutable hash set if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

76. #### final def improve(hcode: Int): Int

    Attributes
      protected

77. #### def init: HashSet[A]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a immutable hash set consisting of all elements of this immutable hash set except the last one.

    Definition Classes
      TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the immutable hash set is empty.

78. #### def inits: Iterator[HashSet[A]]

    Iterates over the inits of this immutable hash set.

    Iterates over the inits of this immutable hash set. The first value will be this immutable hash set and the final one will be an empty immutable hash set, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this immutable hash set

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

79. #### def intersect(that: GenSet[A]): HashSet[A]

    Computes the intersection between this set and another set.

    Computes the intersection between this set and another set.

    that

      the set to intersect with.

    returns

      a new set consisting of all elements that are both in this set and in the given set `that`.

    Definition Classes
      GenSetLike

80. #### def isEmpty: Boolean

    Tests if this set is empty.

    Tests if this set is empty.

    returns

      `true` if there is no element in the set, `false` otherwise.

    Definition Classes
      SetLike → IterableLike → GenIterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

81. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

82. #### final def isTraversableAgain: Boolean

    Tests whether this immutable hash set can be repeatedly traversed.

    Tests whether this immutable hash set can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

83. #### def iterator: Iterator[A]

    Creates a new iterator over all elements contained in this iterable object.

    Creates a new iterator over all elements contained in this iterable object.

    returns

      the new iterator

    Definition Classes
      HashSet → GenSetLike → IterableLike → GenIterableLike

84. #### def last: A

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this immutable hash set.

    Definition Classes
      TraversableLike
    Exceptions thrown
      NoSuchElementException

      If the immutable hash set is empty.

85. #### def lastOption: Option[A]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this immutable hash set$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

86. #### abstract def map[B](f: (A) ⇒ B): immutable.HashSet[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable hash set.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable hash set.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this immutable hash set and collecting the results.

    Definition Classes
      GenTraversableLike

87. #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[HashSet[A], B, That]): That

    Builds a new collection by applying a function to all elements of this immutable hash set.

    Builds a new collection by applying a function to all elements of this immutable hash set.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this immutable hash set and collecting the results.

    Definition Classes
      SetLike → TraversableLike → GenTraversableLike → FilterMonadic
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) Set.map now returns a Set, so it will discard duplicate values.

88. #### abstract def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this immutable hash set with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

89. #### def max[B >: A](implicit cmp: Ordering[B]): A

    Finds the largest element.

    Finds the largest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the largest element of this immutable hash set with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

90. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

    Definition Classes
      TraversableOnce → GenTraversableOnce

91. #### abstract def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this immutable hash set with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

92. #### def min[B >: A](implicit cmp: Ordering[B]): A

    Finds the smallest element.

    Finds the smallest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the smallest element of this immutable hash set with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

93. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

    Definition Classes
      TraversableOnce → GenTraversableOnce

94. #### def mkString: String

    Displays all elements of this immutable hash set in a string.

    Displays all elements of this immutable hash set in a string.

    returns

      a string representation of this immutable hash set. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this immutable hash set follow each other without any separator string.

    Definition Classes
      TraversableOnce → GenTraversableOnce

95. #### def mkString(sep: String): String

    Displays all elements of this immutable hash set in a string using a separator string.

    Displays all elements of this immutable hash set in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this immutable hash set. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this immutable hash set are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

96. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this immutable hash set in a string using start, end, and separator strings.

    Displays all elements of this immutable hash set in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this immutable hash set. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this immutable hash set are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

97. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

98. #### def newBuilder: Builder[A, HashSet[A]]

    A common implementation of `newBuilder` for all sets in terms of `empty`.

    A common implementation of `newBuilder` for all sets in terms of `empty`. Overridden for mutable sets in `mutable.SetLike`.

    Attributes
      protected[this]
    Definition Classes
      SetLike → TraversableLike → HasNewBuilder

99. #### def nonEmpty: Boolean

    Tests whether the immutable hash set is not empty.

    Tests whether the immutable hash set is not empty.

    returns

      `true` if the immutable hash set contains at least one element, `false` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

100. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

101. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

102. #### def par: ParHashSet[A]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       HashSet → CustomParallelizable → Parallelizable

103. #### def parCombiner: Combiner[A, ParHashSet[A]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       CustomParallelizable → Parallelizable

104. #### def partition(p: (A) ⇒ Boolean): (HashSet[A], HashSet[A])

     Partitions this immutable hash set in two immutable hash sets according to a predicate.

     Partitions this immutable hash set in two immutable hash sets according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of immutable hash sets: the first immutable hash set consists of all elements that satisfy the predicate `p` and the second immutable hash set consists of all elements that don't. The relative order of the elements in the resulting immutable hash sets is the same as in the original immutable hash set.

     Definition Classes
       TraversableLike → GenTraversableLike

105. #### abstract def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this immutable hash set with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

106. #### def product[B >: A](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this immutable hash set with respect to the `*` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

107. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this immutable hash set using the specified associative binary operator.

     Reduces the elements of this immutable hash set using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the immutable hash set is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this immutable hash set is empty.

108. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

     Definition Classes
       TraversableOnce

109. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this immutable hash set, going left to right.

     Optionally applies a binary operator to all elements of this immutable hash set, going left to right.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this immutable hash set is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

110. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this immutable hash set, if any, using the specified associative binary operator.

     Reduces the elements of this immutable hash set, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

111. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

     Applies a binary operator to all elements of this immutable hash set, going right to left.

     Applies a binary operator to all elements of this immutable hash set, going right to left.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this immutable hash set, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this immutable hash set.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this immutable hash set is empty.

112. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this immutable hash set, going right to left.

     Optionally applies a binary operator to all elements of this immutable hash set, going right to left.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this immutable hash set is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

113. #### def removed0(key: A, hash: Int, level: Int): HashSet[A]

     Attributes
       protected

114. #### def repr: HashSet[A]

     The collection of type immutable hash set underlying this `TraversableLike` object.

     The collection of type immutable hash set underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

115. #### def reversed: List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

116. #### abstract def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this immutable hash set.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this immutable hash set.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

117. #### def sameElements[B >: A](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this immutable hash set.

     Checks if the other iterable collection contains the same elements in the same order as this immutable hash set.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike

118. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[HashSet[A], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new immutable hash set containing the prefix scan of the elements in this immutable hash set

     Definition Classes
       TraversableLike → GenTraversableLike

119. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[HashSet[A], B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

120. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[HashSet[A], B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

121. #### def seq: Set[A]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Set → Set → GenSet → GenSetLike → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

122. #### def size: Int

     The size of this immutable hash set.

     The size of this immutable hash set.

     returns

       the number of elements in this immutable hash set.

     Definition Classes
       HashSet → GenTraversableLike → TraversableOnce → GenTraversableOnce

123. #### def slice(from: Int, until: Int): HashSet[A]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the lowest index to include from this immutable hash set.

     until

       the highest index to EXCLUDE from this immutable hash set.

     returns

       a immutable hash set containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this immutable hash set.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

124. #### def sliding[B >: A](size: Int, step: Int): Iterator[HashSet[A]]

     Definition Classes
       IterableLike

125. #### def sliding[B >: A](size: Int): Iterator[HashSet[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing immutable hash sets of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

126. #### def span(p: (A) ⇒ Boolean): (HashSet[A], HashSet[A])

     Splits this immutable hash set into a prefix/suffix pair according to a predicate.

     Splits this immutable hash set into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this immutable hash set whose elements all satisfy `p`, and the rest of this immutable hash set.

     Definition Classes
       TraversableLike → GenTraversableLike

127. #### def splitAt(n: Int): (HashSet[A], HashSet[A])

     Splits this immutable hash set into two at a given position.

     Splits this immutable hash set into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of immutable hash sets consisting of the first `n` elements of this immutable hash set, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

128. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this set. Unless overridden this is simply `"Set"`.

     Definition Classes
       SetLike → TraversableLike → GenTraversableLike

129. #### def subsetOf(that: GenSet[A]): Boolean

     Tests whether this set is a subset of another set.

     Tests whether this set is a subset of another set.

     that

       the set to test.

     returns

       `true` if this set is a subset of `that`, i.e. if every element of this set is also an element of `that`.

     Definition Classes
       GenSetLike

130. #### def subsets: Iterator[HashSet[A]]

     An iterator over all subsets of this set.

     An iterator over all subsets of this set.

     returns

       the iterator.

     Definition Classes
       SetLike

131. #### def subsets(len: Int): Iterator[HashSet[A]]

     An iterator over all subsets of this set of the given size.

     An iterator over all subsets of this set of the given size. If the requested size is impossible, an empty iterator is returned.

     len

       the size of the subsets.

     returns

       the iterator.

     Definition Classes
       SetLike

132. #### abstract def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this immutable hash set with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

133. #### def sum[B >: A](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this immutable hash set with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

134. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

135. #### def tail: HashSet[A]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a immutable hash set consisting of all elements of this immutable hash set except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the immutable hash set is empty.

136. #### def tails: Iterator[HashSet[A]]

     Iterates over the tails of this immutable hash set.

     Iterates over the tails of this immutable hash set. The first value will be this immutable hash set and the final one will be an empty immutable hash set, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this immutable hash set

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

137. #### def take(n: Int): HashSet[A]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       Tt number of elements to take from this immutable hash set.

     returns

       a immutable hash set consisting only of the first `n` elements of this immutable hash set, or else the whole immutable hash set, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

138. #### def takeRight(n: Int): HashSet[A]

     Selects last n elements.

     Selects last n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take

     returns

       a immutable hash set consisting only of the last `n` elements of this immutable hash set, or else the whole immutable hash set, if it has less than `n` elements.

     Definition Classes
       IterableLike

139. #### def takeWhile(p: (A) ⇒ Boolean): HashSet[A]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this immutable hash set whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

140. #### def thisCollection: Iterable[A]

     The underlying collection seen as an instance of `immutable.HashSet`.

     The underlying collection seen as an instance of `immutable.HashSet`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

141. #### abstract def toArray: Array[A]

     [use case] Converts this immutable hash set to an array.

     [use case]

     Converts this immutable hash set to an array.

     returns

       an array containing all elements of this immutable hash set.

     Definition Classes
       GenTraversableOnce

142. #### def toArray[B >: A](implicit arg0: ClassManifest[B]): Array[B]

     Converts this immutable hash set to an array.

     Converts this immutable hash set to an array.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this immutable hash set.

     Definition Classes
       TraversableOnce → GenTraversableOnce

143. #### def toBuffer[A1 >: A]: Buffer[A1]

     Converts this immutable hash set to a mutable buffer.

     Converts this immutable hash set to a mutable buffer.

     returns

       a buffer containing all elements of this immutable hash set.

     Definition Classes
       SetLike → TraversableOnce → GenTraversableOnce

144. #### def toCollection(repr: HashSet[A]): Iterable[A]

     A conversion from collections of type `Repr` to `immutable.HashSet` objects.

     A conversion from collections of type `Repr` to `immutable.HashSet` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

145. #### def toIndexedSeq[B >: A]: IndexedSeq[B]

     Converts this immutable hash set to an indexed sequence.

     Converts this immutable hash set to an indexed sequence.

     returns

       an indexed sequence containing all elements of this immutable hash set.

     Definition Classes
       TraversableOnce → GenTraversableOnce

146. #### def toIterable: Iterable[A]

     Converts this immutable hash set to an iterable collection.

     Converts this immutable hash set to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this immutable hash set.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

147. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this immutable hash set.

     Returns an Iterator over the elements in this immutable hash set. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this immutable hash set.

     Definition Classes
       TraversableLike → GenTraversableOnce

148. #### def toList: List[A]

     Converts this immutable hash set to a list.

     Converts this immutable hash set to a list.

     returns

       a list containing all elements of this immutable hash set.

     Definition Classes
       TraversableOnce → GenTraversableOnce

149. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this immutable hash set to a map.

     [use case]

     Converts this immutable hash set to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this immutable hash set.

     Definition Classes
       GenTraversableOnce

150. #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

     Converts this immutable hash set to a map.

     Converts this immutable hash set to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this immutable hash set.

     Definition Classes
       TraversableOnce → GenTraversableOnce

151. #### def toSeq: Seq[A]

     Overridden for efficiency.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this immutable hash set.

     Definition Classes
       SetLike → TraversableOnce → GenTraversableOnce

152. #### def toSet[B >: A]: Set[B]

     Converts this immutable hash set to a set.

     Converts this immutable hash set to a set.

     returns

       a set containing all elements of this immutable hash set.

     Definition Classes
       Set → TraversableOnce → GenTraversableOnce

153. #### def toStream: Stream[A]

     Converts this immutable hash set to a stream.

     Converts this immutable hash set to a stream.

     returns

       a stream containing all elements of this immutable hash set.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

154. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       SetLike → Function1 → TraversableLike → AnyRef → Any

155. #### def toTraversable: Traversable[A]

     Converts this immutable hash set to an unspecified Traversable.

     Converts this immutable hash set to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this immutable hash set.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

156. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): HashSet[HashSet[B]]

     Transposes this immutable hash set of traversable collections into a immutable hash set of immutable hash sets.

     Transposes this immutable hash set of traversable collections into a immutable hash set of immutable hash sets.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this immutable hash set is a `Traversable`.

     returns

       a two-dimensional immutable hash set of immutable hash sets which has as nth row the nth column of this immutable hash set.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this immutable hash set are not of the same size.

157. #### def union(that: GenSet[A]): HashSet[A]

     Computes the union between of set and another set.

     Computes the union between of set and another set.

     that

       the set to form the union with.

     returns

       a new set consisting of all elements that are in this set or in the given set `that`.

     Definition Classes
       SetLike → GenSetLike

158. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (HashSet[A1], HashSet[A2])

     Converts this immutable hash set of pairs into two collections of the first and second half of each pair.

     Converts this immutable hash set of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this immutable hash set is a pair.

     returns

       a pair immutable hash sets, containing the first, respectively second half of each element pair of this immutable hash set.

     Definition Classes
       GenericTraversableTemplate

159. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (HashSet[A1], HashSet[A2], HashSet[A3])

     Converts this immutable hash set of triples into three collections of the first, second, and third element of each triple.

     Converts this immutable hash set of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this immutable hash set is a triple.

     returns

       a triple immutable hash sets, containing the first, second, respectively third member of each element triple of this immutable hash set.

     Definition Classes
       GenericTraversableTemplate

160. #### def updated0(key: A, hash: Int, level: Int): HashSet[A]

161. #### def view(from: Int, until: Int): IterableView[A, HashSet[A]]

     Creates a non-strict view of a slice of this immutable hash set.

     Creates a non-strict view of a slice of this immutable hash set.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current immutable hash set, whereas `slice` produces a new immutable hash set.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this immutable hash set, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       IterableLike → TraversableLike

162. #### def view: IterableView[A, HashSet[A]]

     Creates a non-strict view of this immutable hash set.

     Creates a non-strict view of this immutable hash set.

     returns

       a non-strict view of this immutable hash set.

     Definition Classes
       IterableLike → TraversableLike

163. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

164. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

165. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

166. #### def withFilter(p: (A) ⇒ Boolean): FilterMonadic[A, HashSet[A]]

     Creates a non-strict filter of this immutable hash set.

     Creates a non-strict filter of this immutable hash set.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this immutable hash set which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

167. #### def writeReplace(): AnyRef

     Attributes
       protected

168. #### abstract def zip[B](that: GenIterable[B]): immutable.HashSet[(A, B)]

     [use case] Returns a immutable hash set formed from this immutable hash set and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable hash set formed from this immutable hash set and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this immutable hash set and `that`. The length of the returned collection is the minimum of the lengths of this immutable hash set and `that`.

     Definition Classes
       GenIterableLike

169. #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[HashSet[A], (A1, B), That]): That

     Returns a immutable hash set formed from this immutable hash set and another iterable collection by combining corresponding elements in pairs.

     Returns a immutable hash set formed from this immutable hash set and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this immutable hash set and `that`. The length of the returned collection is the minimum of the lengths of this immutable hash set and `that`.

     Definition Classes
       IterableLike → GenIterableLike

170. #### abstract def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): immutable.HashSet[(A, B)]

     [use case] Returns a immutable hash set formed from this immutable hash set and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable hash set formed from this immutable hash set and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this immutable hash set is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this immutable hash set.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this immutable hash set and `that`. The length of the returned collection is the maximum of the lengths of this immutable hash set and `that`. If this immutable hash set is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this immutable hash set, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

171. #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[HashSet[A], (A1, B), That]): That

     Returns a immutable hash set formed from this immutable hash set and another iterable collection by combining corresponding elements in pairs.

     Returns a immutable hash set formed from this immutable hash set and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this immutable hash set is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this immutable hash set.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this immutable hash set and `that`. The length of the returned collection is the maximum of the lengths of this immutable hash set and `that`. If this immutable hash set is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this immutable hash set, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

172. #### abstract def zipWithIndex: immutable.HashSet[(A, Int)]

     [use case] Zips this immutable hash set with its indices.

     [use case]

     Zips this immutable hash set with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this immutable hash set paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

173. #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[HashSet[A], (A1, Int), That]): That

     Zips this immutable hash set with its indices.

     Zips this immutable hash set with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this immutable hash set paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike

174. #### def |(that: GenSet[A]): HashSet[A]

     Computes the union between this set and another set.

     Computes the union between this set and another set.

     Note: Same as `union`.

     that

       the set to form the union with.

     returns

       a new set consisting of all elements that are in this set or in the given set `that`.

     Definition Classes
       GenSetLike

### Deprecated Value Members

1. #### def **(that: Set[A]): HashSet[A]

   This method is an alias for `intersect`.

   This method is an alias for `intersect`. It computes an intersection with set `that`. It removes all the elements that are not present in `that`.

   that

     the set to intersect with

   Definition Classes
     SetLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use & instead

2. #### def elements: Iterator[A]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

3. #### def first: A

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

4. #### def firstOption: Option[A]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

5. #### def projection: IterableView[A, HashSet[A]]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

### Inherited from Serializable

### Inherited from CustomParallelizable[A, ParHashSet[A]]

### Inherited from Set[A]

### Inherited from SetLike[A, HashSet[A]]

### Inherited from Subtractable[A, HashSet[A]]

### Inherited from GenSet[A]

### Inherited from GenericSetTemplate[A, HashSet]

### Inherited from GenSetLike[A, HashSet[A]]

### Inherited from (A) ⇒ Boolean

### Inherited from Iterable[A]

### Inherited from IterableLike[A, HashSet[A]]

### Inherited from Equals

### Inherited from GenIterable[A]

### Inherited from GenIterableLike[A, HashSet[A]]

### Inherited from Traversable[A]

### Inherited from Immutable

### Inherited from Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, HashSet]

### Inherited from TraversableLike[A, HashSet[A]]

### Inherited from GenTraversableLike[A, HashSet[A]]

### Inherited from Parallelizable[A, ParHashSet[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, HashSet[A]]

### Inherited from HasNewBuilder[A, HashSet[A]]

### Inherited from AnyRef

### Inherited from Any